<?php
/*
Plugin Name: EEVE WebChat
Plugin URI:
Description: EEVE's WebChat
Author: EEVE
Author URI: 
Version: 1.1
*/


add_action('wp_footer', 'eeawc_eeve_frontend_webchat');
add_action("admin_menu", "eeawc_createEEVEWebChatBackOfficeMenu");
add_action("wp_ajax_eeve_backoffice_webchat", "eeawc_createEEVEWebChatBackOfficeAjaxHandler" );


function eeawc_eeve_frontend_webchat() {
	$eeve_user_idcustomer = get_site_option('eeve_webchat_idcustomer', '');
    if (trim($eeve_user_idcustomer) != '') {
		wp_register_script( 'eeawc_webchat_frontend_script', plugins_url('/frontend.js', __FILE__), array('jquery'));
		wp_enqueue_script( 'eeawc_webchat_frontend_script' );
		wp_localize_script( 'eeawc_webchat_frontend_script', 
							'ajax_object',
							array( 'idCustomer' => $eeve_user_idcustomer )
						  );
    }
}

function eeawc_createEEVEWebChatBackOfficeMenu() {
    add_menu_page("EEVE WebChat", "EEVE WebChat", 4, "eeawc-eeve-webchat-backoffice-page", "eeawc_createEEVEWebChatOfficePage");
}

function eeawc_createEEVEWebChatOfficePage() {
    $eeve_user_found = false;
    $eeve_user_idcustomer = "";


    //recupero l'idcustomer
	$eeve_user_idcustomer = get_site_option('eeve_webchat_idcustomer', '');
    if (trim($eeve_user_idcustomer) != '') {
        $eeve_user_found = true;
    }
	

	if ($eeve_user_found) {
		echo '<span class="eeve_title">EEVE WebChat Configuration</span>';
		echo '<span id="textEMail_Label" class="eeve_span_label" style="display:none;">E-Mail</span>';
		echo '<input type="text" id="textEMail_Value" class="eeve_input_value" style="display:none;"/>';
		echo '<span id="textPassword_Label" class="eeve_span_label" style="display:none;">Password</span>';
		echo '<input type="password" id="textPassword_Value" class="eeve_input_value" style="display:none;" />';
		echo '<span id="textIdCustomer_Label" class="eeve_span_label">Id Customer</span>';
		echo '<span id="textIdCustomer_Value" class="eeve_span_value">' . esc_attr($eeve_user_idcustomer) . '</span>';
		echo '<div class="eeve_spacer">&nbsp;</div>';
		echo '<button id="buttonLogin" class="eeve_button" style="display:none;">Log-in</button>';
		echo '<button id="buttonLogout" class="eeve_button">Log-out</button>';
	} else {
		echo '<span class="eeve_title">EEVE WebChat Configuration</span>';
		echo '<span id="textEMail_Label" class="eeve_span_label">E-Mail</span>';
		echo '<input type="text" id="textEMail_Value" class="eeve_input_value" />';
		echo '<span id="textPassword_Label" class="eeve_span_label">Password</span>';
		echo '<input type="password" id="textPassword_Value" class="eeve_input_value" />';
		echo '<span id="textIdCustomer_Label" class="eeve_span_label" style="display:none;">Id Customer</span>';
		echo '<span id="textIdCustomer_Value" class="eeve_span_value" style="display:none;"></span>';
		echo '<div class="eeve_spacer">&nbsp;</div>';
		echo '<button id="buttonLogin" class="eeve_button">Log-in</button>';
		echo '<button id="buttonLogout" class="eeve_button" style="display:none;">Log-out</button>';
	}


	wp_register_style( 'eeawc_webchat_backoffice_style', plugins_url( '/backoffice.css', __FILE__));
    wp_enqueue_style( 'eeawc_webchat_backoffice_style' );


	wp_register_script( 'eeawc_webchat_backoffice_script', plugins_url('/backoffice.js', __FILE__), array('jquery'));
	wp_enqueue_script( 'eeawc_webchat_backoffice_script' );
	wp_localize_script( 'eeawc_webchat_backoffice_script', 
						'ajax_object',
						array( 'ajax_url' => admin_url( 'admin-ajax.php' )) 
					  );
}

function eeawc_createEEVEWebChatBackOfficeAjaxHandler() {
	$operation = sanitize_text_field(strtolower(trim($_POST['operation'])));


	if ($operation == 'login') {
		$eeve_user_login = sanitize_text_field($_POST['eeve_user_login']);
		$eeve_user_password = sanitize_text_field($_POST['eeve_user_password']);


		$response = wp_remote_post( 'https://api.eeve.ai/token', array(
			'method'      => 'POST',
			'timeout'     => 60,
			'redirection' => 5,
			'httpversion' => '1.0',
			'blocking'    => true,
			'headers'     => array(
				'Content-type' => 'application/x-www-form-urlencoded'
			),
			'body'        => array(
				'client_id' => 'AWPRESS1221',
				'grant_type' => 'password',
				'username' => $eeve_user_login,
				'password' => $eeve_user_password
			),
			'cookies'     => array()
			)
		);


		if (is_wp_error( $response )) {
			/*
			echo $response->get_error_message();
			*/
			$tokenIsValid = false;
		} else {
			try {
				$tokenIsValid = true;
				$result_json = json_decode($response["body"], true);
			} catch (Exception $e) {
				$tokenIsValid = false;
			}
		}


		if ($tokenIsValid == true) {
			$jwt_decode = json_decode(base64_decode(str_replace('_', '/', str_replace('-','+',explode('.', $result_json["access_token"])[1]))));
			$eeve_user_idcustomer = $jwt_decode->idCustomer;


			delete_site_option('eeve_webchat_idcustomer');
			add_site_option('eeve_webchat_idcustomer', $eeve_user_idcustomer);


			echo 'ok_' . esc_attr($eeve_user_idcustomer);
		}
	} elseif ($operation == 'logout') {
		delete_site_option('eeve_webchat_idcustomer');


		echo 'ok';
	}


	wp_die();
}